#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#define YES 1
#define NO  0
/*--------------------------------------------------------------------*/
//   input tape,            output tape         stack
char niz[80],*ptr,*ptr1,    buf[80],*p1,*p2,    stack[80],*sp,*sp1;

// valid character pairs for infix expressions
//                  (   operand   operator   )   #
int tab[4][5] = { { 1,  1,        0,         0,  0 } ,   /*  (        */
						{ 0,  0,        1,         1,  1 } ,   /*  operand  */
						{ 1,  1,        0,         0,  0 } ,   /*  opertaor */
						{ 0,  0,        1,         1,  1 }     /*  )        */
					 } ;
/*--------------------------------------------------------------------*/
void compress(void);   // to ignore white spaces
int syntax(void);      // to check for valid syntax before conversion
void opz(void);        // infix to polish reverse notation converter
int  prior(char, int); // returns dynamic priority of an operator
void fenster(void);
/*--------------------------------------------------------------------*/
void compress(void)    // to ignore white spaces
{
 /* compress of input string, ignore spaces, ptr and ptr1 point to &niz[0] */
  while (*ptr1)
	{
	 while (isspace(*ptr1)) ptr1++;
	 if (ptr != ptr1) *ptr = *ptr1;
	 ptr++;  ptr1++;
	}
  /* explicitly write terminal delimiter '#' and '\0' to the end of the string */
  *ptr++='#';  *ptr='\0';
  gotoxy(1,4); cprintf(" Compressed string:%s",niz);
}
/*--------------------------------------------------------------------*/
int syntax(void)      // to check for valid syntax before conversion
{
  char ch; int row,col,bracket=0; /* flag balance of parentheses */
  ptr = &niz[0];
  if (!(*ptr == '(' || isalnum(*ptr))) /*err no begin with 'a' or '(' */
												  return(1);
  /* input string begins correctly, check for valid character pairs */
				/* until end of input string   */
  ptr++;    /* ptr points to the right character of the input string */
  while (*ptr)
	{
	 row=10;  ch=*(ptr-1); /* left charcter */
	 if (ch=='(')                { bracket++; row=0; }
	 if (isalnum(ch))                         row=1;
	 if (ch=='+' || ch=='-' || ch=='^' ||
		  ch=='*' || ch=='/' || ch=='%' )      row=2;
	 if (ch==')')         { bracket--; if (bracket<0) return(5);
					else row=3; }
	 col=10;  ch=*ptr;    /* right character */
	 if (ch=='(')                             col=0;
	 if (isalnum(ch))                         col=1;
	 if (ch=='+' || ch=='-' || ch=='^' ||
		  ch=='*' || ch=='/' || ch=='%')       col=2;
	 if (ch==')')                             col=3;
	 if (ch=='#')                             col=4;
	 /* different checks follow */
	 if (row==10 || col==10)  return(2); /* err, invalid character */
	 if (tab[row][col]==YES)  ptr++; /* valid character pairs */
		  else  return(3);     /* err, invalid character pair */
	}
	 if (bracket)  return(4);  /* check unbalanced parentheses */
  return(0);  /* normal return exit */
} /* end of syntax() */
/*--------------------------------------------------------------------*/
void opz(void)       // infix to polish reverse notation converter
{
  textbackground(RED); textcolor(WHITE);
  gotoxy(1,6); cprintf("Stack"); gotoxy(41,6); cprintf("Output tape");
  window(1,7,80,23); textbackground(RED); textcolor(WHITE); clrscr();

  ptr = &niz[0];
  while (*ptr)
  {
	 if (*ptr=='#' && *sp=='#') break; /* success */
	 if (isalnum(*ptr)) /* current scanned char is operand, to output tape */
				*p2++ = *ptr++;
		else  /* now current scanned char is an operator */
			 {
			  if (*ptr==')' && *sp=='(')
												 { sp--; ptr++; }
				 else
					/* compare precedence of operators from input and stack */
					if (prior(*ptr,1) > prior(*sp,2))
														  {
														  sp++; *sp=*ptr; ptr++;
														  }
					  else   /* prior(*ptr,1) <= prior(*ptr,2) */
						 {
						  if (*sp != '(')
											 { *p2=*sp; p2++; }
											 sp--;
						 }
			 } /* end of  else */
	 /* ---------- display stack status   */
	 cprintf("\n");
	 gotoxy(1,wherey()); /* kursor na nov red */  sp1 = &stack[0];
	 while (sp1 <= sp)  cprintf("%c",*sp1++);
	 /* ---------- display output tape status  */
	 gotoxy(41,wherey()); /* cursor to pos. 41 */
	 while (p1<p2)  cprintf("%c",*p1++);
	 getch();
	 p1 = &buf[0];
	 /* ---------- end of display  statusa of stack and output */
  } /* end of global while */
  /* now display of result  */
  window(1,24,80,25); textbackground(BLUE); textcolor(CYAN); clrscr();
  gotoxy(1,1);cprintf("   input string:"); cprintf("%s",niz);
  gotoxy(1,2);cprintf("   notation ipn:"); while (p1<p2) cprintf("%c",*p1++);
} /* end of opz() */
/*--------------------------------------------------------------------*/
int prior(char symb, int nmr)  // returns dynamic priority of an operator
//  char symb;  int nmr;
{
 switch (symb)
  {
	 case '#': return(0);
	 case '(': return( (nmr==1) ? 6 : 1 );
	 case ')': return(1);
	 case '+':
	 case '-': return(2);
	 case '*':
	 case '/':
	 case '%': return(3);
	 case '^': return( (nmr==1) ? 5 : 4 );
  }
} /* end of prior() */
/*--------------------------------------------------------------------*/
void fenster(void)
{
  char *t1="Enter input string:";
  char *title="Inverse Polish notation based on Dijkstra's algorithm";
  char *tit  ="-----------------------------------------------------";
  window(1,1,80,25); textbackground(BLUE); textcolor(YELLOW); clrscr();
  gotoxy((80-strlen(tit))/2,1); cprintf("%s",title);
  gotoxy((80-strlen(tit))/2,2); cprintf("%s",tit);
  gotoxy(1,3); cprintf("%s",t1); /* Enter inut string */
} /* end of fenster() */
/*--------------------------------------------------------------------*/
 main()
{
  int x,y; /* work memory cells */
  int flag; /* flag empty input string, includes only spaces */
  char *t2="Syntax correct";
  char *t3="Error 1, invalid begin char";
  char *t4="Error 2, invalid character";
  char *t5="Error 3, invalid character pair";
  char *t6="Error 4, unbalanced parentheses";
  char *t7="Error 5, right ) found before left (";

  fenster(); /* basic window */
  while ((ptr=gets(niz)) != NULL)
  {
			 /* check for empty input string or string with only spaces */
	 ptr1=ptr; flag=0; while (*ptr1) if(!isspace(*ptr1++)) flag=1;
	 x=72; y=25;
	 if (*ptr && flag)
				 /* end of check for empty input string */
		{  /* now unempty input string is to be processes */
		  ptr1 = ptr;
		  p1=&buf[0];   p2=p1;
		  sp=&stack[0]; *sp='#';
		  compress();
	switch(syntax())
			 {
		case 0: gotoxy(1,5); delline(); cprintf("%s",t2);
							opz(); y=2; break;
		case 1: gotoxy(1,5); delline(); cprintf("%s",t3);        break;
		case 2: gotoxy(1,5); delline(); cprintf("%s",t4);        break;
		case 3: gotoxy(1,5); delline(); cprintf("%s",t5);        break;
		case 4: gotoxy(1,5); delline(); cprintf("%s",t6);        break;
		case 5: gotoxy(1,5); delline(); cprintf("%s",t7);        break;
			 }  /* end of switch */
		}  /* end of  if */
		gotoxy(x,y); cprintf("Any key");
		getch(); fenster();
  }  /* end of global while */
}  /* end of main() */
/*--------------------------------------------------------------------*/
